<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Teacher_Index extends Controller_Environment_Teacher
{
    public function action_index() {
        $teacher = Model_Teacher::with($this->user->TeacherID);
        $disciplines = $teacher->getDisciplines();
        $subjID = $discID = $gradeNum = $i = 0;
        $subjects = $teachers = $groups = [];

        foreach ($disciplines as $dis) {
            // group disciplines by subjectID & gradeID
            if ($subjID != $dis->SubjectID || $gradeNum != $dis->GradeID) {
                $subjID = $dis->SubjectID;
                $gradeNum = $dis->GradeID;

                $subjects[++$i] = [
                    'SubjectName' => $dis->SubjectName,
                    'GradeNum'    => $dis->GradeNum,
                    'Degree'      => $dis->Degree,
                ];
            }

            if ($discID != $dis->ID) {
                $discID = $dis->ID;
                $subjects[$i]['Disciplines'][] = $dis;
            }

            // todo: Pavel will write an optimized query
            if (!$dis->Subtype && !$teachers[$dis->ID])
                $teachers[$dis->ID] = $dis->getTeachers();
            if (isset($dis->GroupNum) && $dis->GroupNum)
                $groups[$dis->ID][] = $dis->GroupNum . ' гр.';
        }

        $SemesterInfo = Model_Semesters::getInfo($this->user->SemesterID);
        Model_Semesters::normalizeInfoE($SemesterInfo);

        $this->twig->set([
            'Subjects'     => $subjects,
            'Teachers'     => $teachers,
            'Groups'       => $groups,
            'SemesterList' => Model_Semesters::toArray(),
            'Semester'     => $SemesterInfo,
        ])->set_filename('teacher/index');
    }
    
    public function action_settings() {
        $this->twig->set_filename('settings');
    }
}